import { css, cx } from "@linaria/core";
import { string } from "vue-types";
import { useCompData } from ".";
import { Image, Text } from "../../../basicUI";
import { createUIComp } from "../../../defines/createUIComp";

export const Component = createUIComp({
  props: {
    compId: string().isRequired,
  },
  setup(props) {
    const { children, value } = useCompData(props.compId);

    return () => (
      <div class={cx("relative text-black", rootStyles)}>
        <div class="flex justify-end items-center relative mb-0.4rem">
          <div class="text_top absolute right-0 top-0 h-1/1 w-0"></div>
          <div class="relative z-10 bg-light-50 pr-0.2rem">
            <Text.Component compId={children.text} />
          </div>
        </div>
        <div class="relative">
          <Image.Component
            compId={children.img1}
            class="w-6.22rem h-6.22rem object-cover mx-auto"
          />
          <div
            class="absolute right-5rem top-3rem min-w-1.5rem p-0.08rem pt-1rem border-light-50 border-0.08rem border-top-0.06rem border-solid card_color"
            style={{
              backgroundColor: value.themeColor,
            }}
          >
            <Text.Component compId={children.text2} class="bg-light-50" />
          </div>
        </div>
      </div>
    );
  },
});

const rootStyles = css`
  .text_top {
    &::before {
      content: "";
      position: absolute;
      right: 0;
      top: 50%;
      width: 5rem;
      height: 200%;
      border-width: 1px 0 0 1px;
      border-color: #000;
      border-style: solid;
    }
  }
  .card_color {
    transform: translateX(50%);
    &::before {
      content: "";
      position: absolute;
      left: 50%;
      top: -3.06rem;
      width: 1px;
      height: 3rem;
      background-color: #fff;
    }
  }
`;
